#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf pciutils-3.1.10.tar.bz2
    cd pciutils-3.1.10
    bunzip2 -c ../pciutils-3.0.0-pcimodules-1.patch.bz2 | patch -p1 -b
    make PREFIX=/usr OPT="$CFLAGS" IDSDIR=/usr/share/misc
    strip -R .note -R .comment pcimodules lspci
    mkdir -p ../lspci/bin ../pciids/share/misc ../pcimodules/sbin
    cp lspci ../lspci/bin/
    cp pci.ids.gz ../pciids/share/misc/
    cp pcimodules ../pcimodules/sbin/
    cd ..
    rm -rf pciutils-3.1.10
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
